//packetJSON demo by Andrew Rose
//outputs packet layer information to the console

//Part 1
//#1: copy and paste json data into web console, assign to a variable
//        ex: var p = [json]
//#2: type variable name and hit enter, what do you see? (Array of packet objects)
//#3: isolate a packet, what properties are there? (_index, _type, _score, _source)
//#4: locate the layer object in _source, what layers are present?
//#5: try to access data from a specific layer (*Hint: use brackets ["prop"] instead of .prop)

//Part 2
//2.1: Print out the layers of each packet (*at least 2 will be present: frame and ethernet)
//2.2: Print out layer 1 frame length
//2.3: Print out layer 2 ethernet mac addresses: source --> destination
//2.4: Print out layer 3 IP addresses: source --> destination (if present)
//2.5: Print out layer 4 TCP/UDP port numbers: source --> destination (if present)

//must link to p5.dom in index.html for createFileInput
function setup() {
  noCanvas();
  createFileInput(gotFile); //user must select valid wireshark JSON
}

//called whenever a file is selected
function gotFile(file) {
  loadJSON(file.data, parseJSON);
}

//called once JSON is loaded
function parseJSON(data) {
  //look at each packet i in data
  for (var i = 0; i < data.length; i++) {
    //create a layer variable
    var layer = data[i]._source.layers; //['_source']['layers'];

    var layers = "";
    for (var prop in layer) {
      layers += prop + " ";
    }
    //2.1: Print layer information
    console.log("packet " + i + ": [ " + layers + "]")
      //2.2: Print out layer 1 frame length
    console.log("  frame: " + layer.frame["frame.len"])
      //2.3: Print out layer 2 ethernet mac addresses: source --> destination
    console.log("  eth: " + layer.eth["eth.src"] + " --> " + layer.eth["eth.dst"])
      //2.4: Print out layer 3 IP addresses: source --> destination 
    if (layer.ip) { //IP packets
      console.log("  ip: " + layer.ip["ip.src"] + " --> " + layer.ip["ip.dst"])
      //2.5: Print out layer 4 TCP/UDP port numbers: source --> destination
      if (layer.tcp) //tcp protocol
        console.log("  tcp: " + layer.tcp["tcp.srcport"] + " --> " + layer.tcp["tcp.dstport"])
      else //must be udp
        console.log("  udp: " + layer.udp["udp.srcport"] + " --> " + layer.udp["udp.dstport"])
    }
  }
}